# -*- coding: utf-8 -*-

"""
Django settings for pai2 project.

Generated by 'django-admin startproject' using Django 1.8.4.

For more information on this file, see
https://docs.djangoproject.com/en/1.8/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.8/ref/settings/
"""

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import os


BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
PROJ_DIR = os.path.abspath(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.8/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'aam6@6bh17d87bn-ax1@mcdrtbfm02y)_twd&!ewrr2^4581!c'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = (
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'django_rlog',
    'django_q',
    'api',
    'account',
    'geo',
    'group',
    'message',
    'miniapp',
    'operation',
    'page',
    'pay',
    'photo',
    'website',
)

INSTALLED_APPS += ('multidomain', )

MIDDLEWARE_CLASSES = (
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    # 'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'detect.middleware.UserAgentDetectionMiddleware',
)

MIDDLEWARE_CLASSES += ('multidomain.middleware.DomainMiddleware', )

URL_CONFIG = (
    # (r'^(.+\.)?xfoto\.com\.cn', 'pai2.urls_www'),
    (r'^(.+\.)?api\.pai\.ai', 'pai2.urls_api'),
)

ROOT_URLCONF = 'pai2.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        # 'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
            'loaders': [
                ('django.template.loaders.cached.Loader', [
                    'django.template.loaders.filesystem.Loader',
                    'django.template.loaders.app_directories.Loader',
                ]),
            ],
        },
    },
]

WSGI_APPLICATION = 'pai2.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.8/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'pai2',
        'USER': 'root',
        'PASSWORD': '',
        'CONN_MAX_AGE': 600,
        'OPTIONS': {
            # Utf8mb4 for Emoji
            # account.WechatInfo ==> nickname
            #   ALTER TABLE account_wechatinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci;
            # account.UserInfo ==> nickname
            #   ALTER TABLE account_userinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci;
            # group.GroupUserInfo ==> nickname
            #   ALTER TABLE group_groupuserinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL;
            # group.GroupPhotoInfo ==> nickname
            #   ALTER TABLE group_groupphotoinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL;
            # group.PhotoCommentInfo ==> nickname
            #   ALTER TABLE group_photocommentinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL;
            # group.PhotoThumbUpInfo ==> nickname
            #   ALTER TABLE group_photothumbupinfo MODIFY COLUMN nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL;
            # group.UserMessageInfo ==> nickname
            #   ALTER TABLE message_usermessageinfo MODIFY COLUMN from_nickname VARCHAR(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL;
            'charset': 'utf8mb4',
        },
    }
}

SCHEMES = {
    'django.db.backends.postgresql_psycopg2': 'postgres',
    'django.db.backends.postgresql_psycopg2': 'postgresql',
    'django.db.backends.postgresql_psycopg2': 'pgsql',
    'django.contrib.gis.db.backends.postgis': 'postgis',
    'django.db.backends.mysql': 'mysql',
    # 'django.db.backends.mysql': 'mysql2',
    'django.contrib.gis.db.backends.mysql': 'mysqlgis',
    'mysql.connector.django': 'mysql-connector',
    'django.contrib.gis.db.backends.spatialite': 'spatialite',
    'django.db.backends.sqlite3': 'sqlite',
    'django.db.backends.oracle': 'oracle',
    'django.contrib.gis.db.backends.oracle': 'oraclegis',
}

DATABASE_URL = {
    k: '{scheme}://{user}:{password}@{host}:{port}/{name}?charset={charset}'.format(
        scheme=SCHEMES[v.get('ENGINE', '')],
        user=v.get('USER', 'root'),
        password=v.get('PASSWORD', ''),
        host=v.get('HOST', 'localhost'),
        port=v.get('PORT', 6039),
        name=v.get('NAME', ''),
        charset=v.get('OPTIONS', {}).get('charset', 'utf8'),
    ) for k, v in DATABASES.iteritems()
}

# Internationalization
# https://docs.djangoproject.com/en/1.8/topics/i18n/

LANGUAGE_CODE = 'zh-Hans'

TIME_ZONE = 'Asia/Shanghai'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.8/howto/static-files/

STATICFILES_DIRS = (
    os.path.join(PROJ_DIR, 'static').replace('\\', '/'),
)

STATIC_ROOT = os.path.join(BASE_DIR, 'collect_static').replace('\\', '/')

STATIC_URL = '/static/'

STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    # 'django.contrib.staticfiles.finders.DefaultStorageFinder',
)

MEDIA_ROOT = os.path.join(BASE_DIR, 'media').replace('\\', '/')

MEDIA_URL = '/media/'

# REST_FRAMEWORK 设置
# See http://www.django-rest-framework.org/#example
REST_FRAMEWORK = {
    # Use Django's standard `django.contrib.auth` permissions,
    # or allow read-only access for unauthenticated users.
    # 'DEFAULT_PERMISSION_CLASSES': [
    #     'rest_framework.permissions.DjangoModelPermissionsOrAnonReadOnly',
    # ]
    'DEFAULT_PERMISSION_CLASSES': ('rest_framework.permissions.DjangoModelPermissionsOrAnonReadOnly',),
    'PAGE_SIZE': 1
}

# Redis 设置
REDIS = {
    'default': {
        'HOST': '127.0.0.1',
        'PORT': 6379,
        'USER': '',
        'PASSWORD': '',
        'db': 0,
    }
}

# 微信设置
WECHAT = {
    'JSAPI': {
        'token': '5201314',
        'appID': '',
        'appsecret': '',
        'mchID': '',
        'apiKey': '',
        'mch_cert': '',
        'mch_key': '',
        'redpacket': {

        }
    },
}

# 微信授权设置
WECHAT_BASE_REDIRECT_URI = 'https://api.pai.ai/base_redirect'
WECHAT_USERINFO_REDIRECT_URI = 'https://api.pai.ai/userinfo_redirect'
WECHAT_OAUTH2_RETRY_REDIRECT_URI = 'https://api.pai.ai/wx_oauth2?redirect_url={}'

WECHAT_OAUTH2_REDIRECT_URL = 'https://api.pai.ai/wx_oauth2?redirect_url={}'

# 图片设置
FILE_UPLOAD_MAX_MEMORY_SIZE = 5242880  # InMemoryUploadedFile 文件最大值
FILE_UPLOAD_PERMISSIONS = 0o644  # TemporaryUploadedFile 文件权限设置

# 唯一标识设置
CURTAIL_UUID_LENGTH = 7

# 水印设置
WATERMARK_LOGO = os.path.join(PROJ_DIR, 'static/pai2/img/paiai_96_96.png').replace('\\', '/')

# 原图设置
LENSMAN_PHOTO_ORIGIN_EXPIRED_MSEL = 604800000  # 摄影师原图过期毫秒数，7d = 7 * 24 * 3600 * 1000msel

# 缩略图设置
THUMBNAIL_MAX_WIDTH = 540
THUMBNAIL_MAX_WIDTH2 = 1080

# 首页设置
PAI2_HOME_PER_PAGE = 20  # 首页照片每页数量
PAI2_HOME_MAX_PAGE = 20  # 首页照片最大页数
PAI2_HOME_MAX_ROWS = 400  # 首页照片最大数量，PAI2_HOME_PER_PAGE * PAI2_HOME_MAX_PAGE = 20 * 20 = 400

# 下载页设置
TMPL_DOWNLOAD_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/download.tmpl.html').replace('\\', '/')

PAI2_USER_DOWNLOAD_ADR_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_user_adr_download.html').replace('\\', '/')
PAI2_USER_DOWNLOAD_IOS_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_user_ios_download.html').replace('\\', '/')

PAI2_LENSMAN_DOWNLOAD_ADR_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_lensman_adr_download.html').replace('\\', '/')
PAI2_LENSMAN_DOWNLOAD_IOS_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_lensman_ios_download.html').replace('\\', '/')

PAI2_TOURGUIDE_DOWNLOAD_ADR_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_tourguide_adr_download.html').replace('\\', '/')
PAI2_TOURGUIDE_DOWNLOAD_IOS_PAGE_PATH = os.path.join(BASE_DIR, 'page/templates/page/pai2_tourguide_ios_download.html').replace('\\', '/')

# 下载设置
PAI2_USER_DOWNLOAD_WX_URL = 'https://pai.ai'
PAI2_USER_DOWNLOAD_IOS_URL = 'https://pai.ai'

PAI2_LENSMAN_DOWNLOAD_WX_URL = 'https://pai.ai'
PAI2_LENSMAN_DOWNLOAD_IOS_URL = 'https://pai.ai'

PAI2_TOURGUIDE_DOWNLOAD_WX_URL = 'https://pai.ai'
PAI2_TOURGUIDE_DOWNLOAD_IOS_URL = 'https://pai.ai'

# 群组设置
GROUP_PER_PAGE = 20  # 群组每页数量

# 游客设置
GUEST_USER_ID = 'guest'

# 版本设置
MIN_VERSION = '0.0.0'
MAX_VERSION = '999.999.999'
CURRENT_VERSION = '1.0.0'

# 价格设置
LENSMAN_PHOTO_HAGGLE_MAX_TIMES = 3  # 摄影师照片最大砍价次数

# 订单设置
ORDER_NUM_PER_PAGE = 10  # 订单每页数量

# 域名设置
DOMAIN = 'https://pai.ai'
IMG_DOMAIN = 'https://img.pai.ai'
API_DOMAIN = 'https://api.pai.ai'

# 消息图片设置
PAI2_LOGO_URL = DOMAIN + '/static/pai2/img/paiai_96_96.png'

SYSTEM_MESSAGE_AVATAR = PAI2_LOGO_URL
COMMENT_MESSAGE_AVATAR = PAI2_LOGO_URL
THUMBUP_MESSAGE_AVATAR = PAI2_LOGO_URL

MESSAGE_NUM_PER_PAGE = 10  # 消息每页数量

LOGIT_BODY_FLAG = True
LOGIT_RES_FLAG = True

try:
    from local_settings import *
except ImportError:
    pass

try:
    from func_settings import redis_connect
    REDIS_CACHE = redis_connect(REDIS.get('default', {}))

    Q_CLUSTER = {
        'name': 'pai2',
        'workers': 8,
        'recycle': 500,
        'timeout': 60,
        'compress': True,
        'cpu_affinity': 1,
        'save_limit': 250,
        'queue_limit': 500,
        'label': 'Django Q',
        'redis_conn': REDIS_CACHE,
    }

    DJLOGIT = {
        'level': 'DEBUG',
        'class': 'rlog.RedisListHandler',
        'redis_client': REDIS_CACHE,
        'key': 'django:logit:pai2',
        'formatter': 'verbose',
    }
except ImportError:
    REDIS_CACHE = None

# logger setting
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '%(levelname)s %(asctime)s %(module)s %(process)d %(thread)d %(message)s'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'logit': DJLOGIT,
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'verbose'
        },
    },
    'loggers': {
        'logit': {
            'handlers': ['logit'],
            'level': 'DEBUG',
            'propagate': True,
        },
        'console': {
            'handlers': ['console'],
            'level': 'DEBUG',
            'propagate': True,
        },
    },
}
